Subject: bug#31065: relationship with Zlib? Re: bug#31065: Version 2??

From: Mark Adler <[email-masked]>
Date: Wed, 2 May 2018 09:54:19 -0700

pigz isn’t under GPL either. It has the same zlib license that zlib has. Interestingly the “zlib license” has become a thing onto itself and used by others, as one of the approved licenses by FSF and OSI. FSF calls the zlib license “GPL compatible”, whatever that means.

For pigz to eventually replace and be called “gzip", does it need to be under GPL?

As to the history of gzip and zlib, gzip was written first, itself derived from earlier Info-ZIP code. zlib was written a few years later by the same authors for compression and decompression, but they both made changes to the code and algorithms. So, for example, the compressed data that comes out of gzip will generally be different than for zlib, for the same input and compression level. They are completely compatible with each other, conforming to the deflate format. I am not aware of any reason that gzip couldn’t use zlib, but it just happens not to.

> On May 2, 2018, at 7:12 AM, Garreau, Alexandre <[email-masked]> wrote:
> 
> Sorry, in my excitement, I sent my last mail without looking at what I
> wanted to say/ask in my first draft:
> 
> I’m not sure of recalling or understanding fully, but isn’t pigz
> somewhat linked with Zlib/Zlib code? and Zlib not being GNU, what would
> that mean? would it have to be separated? would gzip get Zlib as a
> mandatory dependency? How would that evolve?
> 
> As I understood anyway you Mark Adler the maintainer of Zlib are anyway
> quite active on these mailing-lists.  Out of curiosity, and I’m probably
> bad at formulating it at a quick glance but I’m not sure of what are the
> relationships and differences between zlib and the (redundant?
> different? independant?)  standalone compression tools it reimplements
> (or the other way around?), including gzip, especially when some people
> working on all these are the same: then there must be some relevant
> useful difference that justify the differenciation of both?
> 
> I first learnt about pigz on a (french) (micro)blogger website [1], then
> I was really curious about why a such useful and uncontroversial change
> wouldn’t go upstream (as afaik stuff not going upstream for gcc or glibc
> has been common for several times in their history), not only for gzip
> but also for lzip, xz, bzip2, etc.
> 
> Thank you in advance for any answer!
> 
> [1] fr: <http://sebsauvage.net/links/?DrNtGw>